import { Component, OnInit } from '@angular/core';
import {TesService} from '../tes.service';
import { Job } from '../job';
import { Observable } from 'rxjs/Observable';



@Component({
  selector: 'app-joblist',
  templateUrl: './joblist.component.html',
  styleUrls: ['./joblist.component.css']
})
export class JoblistComponent implements OnInit {
  public jobs: any[] = [];
  private displayedColumns = ['id'];
  private jobsSubscription: any;

  constructor(private tesService: TesService,) { }

  ngOnInit() {

    this.jobsSubscription = this.tesService.joblist.subscribe(jobs => this.jobs = jobs);
    console.log("jobs subscribed by joblist component");
  }

  public ngOnDestroy(): void {
      if (this.jobsSubscription) {
          this.jobsSubscription.unsubscribe();
      }

  }

  updateJobs(jobs) {
    this.jobs = jobs;
    console.log("job data received by the joblist component");
    console.log(this.jobs);
  }

  login(){
    //Wire this up to the tes login component to get an ssh cert on the tes backend
    //This will also tell the TES which site we are using
    return;
  }

  logout() {
    return;
  }

}
