import { Component, OnInit, NgModule, Inject } from '@angular/core';
import {Strudelapp} from '../strudelapp';
import { StrudelappsService } from '../strudelapps.service';
import { MatDialog, MatDialogRef, MAT_DIALOG_DATA, MatDialogModule } from '@angular/material';
import { TesService } from '../tes.service';
import {Identity } from '../identity';



@Component({
  selector: 'app-launcher',
  templateUrl: './launcher.component.html',
  styleUrls: ['./launcher.component.css']
})
export class LauncherComponent implements OnInit {
  private strudelapps: Strudelapp[];

  private app: Strudelapp;
  public authorised: boolean;
  private identity: Identity;

  constructor(private strudelappsService: StrudelappsService, public dialog: MatDialog, private tesService: TesService) { }

  ngOnInit() {
    this.loadStrudelapps();
    setTimeout( () => { this.tesService.authorised.subscribe(auth => this.authorised = auth); });
  }


  configureApp() {
    console.log('configuring app for',this.app.name);
    this.openDialog('If the application takes any parameters, this will open a new window where you can configure them')
  }

  configureResources() {
    this.openDialog('This will open a new window to configure resource reqests')
  }

  submitApp() {
    console.log('submitting app for',this.app.name);
    this.identity = this.tesService.identities[0];
    this.tesService.submit(this.app, this.identity);
    // this.openDialog('This is where we should start the app');
  }

  appselect(a: any) {
    console.log('appselect')
    this.app = a;
  }

  loadStrudelapps() {
    this.strudelapps = this.strudelappsService.getStrudelapps()
  }


  openDialog(msg: string ): void {
      let dialogRef = this.dialog.open(DialogPlaceholder, {
        width: '250px',
        height: '400px',
        data: { 'msg': msg }
      });

      dialogRef.afterClosed().subscribe(result => {
        console.log('The dialog was closed');
      });
    }


}

@Component({
  selector: 'dialog-placeholder',
  templateUrl: 'dialog-placeholder.html',
})
export class DialogPlaceholder {

  constructor(
    public dialogRef: MatDialogRef<DialogPlaceholder>,
    @Inject(MAT_DIALOG_DATA) public data: any) { }

  onNoClick(): void {
    this.dialogRef.close();
  }

}
